-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

Hedd.aui=_G.C_ArtifactUI

lib.PrintArtifact=function()
	UIParent:UnregisterEvent("ARTIFACT_UPDATE")
	SocketInventoryItem(16);
	for i,p in ipairs(Hedd.aui.GetPowers()) do
		--print(GetSpellInfo((Hedd.aui.GetPowerInfo(p))))
		local spellID, _, currentRank, maxRank, bonusRanks, _, _, _, isStart, isGold, isFinal = Hedd.aui.GetPowerInfo(p)
		print(spellID.." - "..(select(1,GetSpellInfo(spellID))).." "..currentRank)
	end
	Hedd.aui.Clear()
	UIParent:RegisterEvent("ARTIFACT_UPDATE")
end

lib.UpdateArtifact=function()
	if not HeddDB.artifact then return end
	if Hedd.aui.GetNumObtainedArtifacts()>0 and HasArtifactEquipped() and not UnitHasVehicleUI("player") then
		if cfg.Artifact.known then
			lib.UpdateArtifactLevel()
		else
			Heddtalents:UnregisterEvent("ARTIFACT_UPDATE")
			_G.UIParent:UnregisterEvent("ARTIFACT_UPDATE")
			if _G.ArtifactFrame then --and not _G.ArtifactFrame:IsShown()
				_G.ArtifactFrame:UnregisterEvent("ARTIFACT_UPDATE")
			end

			if _G.ArtifactFrame and _G.ArtifactFrame:IsShown() then
				cfg.Artifact.wasopen=true
			else
				cfg.Artifact.wasopen=false
				SocketInventoryItem(INVSLOT_MAINHAND)
			end
			cfg.Artifact.itemID, cfg.Artifact.altItemID, cfg.Artifact.name, cfg.Artifact.icon, cfg.Artifact.xp, cfg.Artifact.pointsSpent, cfg.Artifact.quality, cfg.Artifact.artifactAppearanceID, cfg.Artifact.appearanceModID, cfg.Artifact.itemAppearanceID, cfg.Artifact.altItemAppearanceID, cfg.Artifact.altOnTop = Hedd.aui.GetEquippedArtifactInfo()
			cfg.Artifact.currentArtifactPurchasableTraits = MainMenuBar_GetNumArtifactTraitsPurchasableFromXP(cfg.Artifact.pointsSpent, cfg.Artifact.xp)
			cfg.Artifact.powers=Hedd.aui.GetPowers()
			if cfg.Artifact.powers then
				for i = 1, #cfg.Artifact.powers do
					local spellID, cost, currentRank, maxRank, bonusRanks, x, y, prereqsMet, isStart, isGoldMedal, isFinal = Hedd.aui.GetPowerInfo(cfg.Artifact.powers[i])
					local name, _, texture = GetSpellInfo(spellID);
					cfg.Artifact.traits[spellID]={
						traitID=cfg.Artifact.powers[i],
						cost=cost,
						currentRank=currentRank,
						maxRank=maxRank,
						bonusRanks=bonusRanks,
						x=x,
						y=y,
						prereqsMet=prereqsMet,
						isGoldMedal=isGoldMedal,
						isFinal=isFinal,
						name=name,
						texture=texture,
						}
				end
			end
			--Hedd.aui.Clear()
			cfg.Artifact.known=true
			Heddtalents:RegisterEvent("ARTIFACT_UPDATE")
			if _G.ArtifactFrame and not cfg.Artifact.wasopen then
				--Hedd.aui.Clear()
				HideUIPanel(ArtifactFrame)
			end
			if _G.ArtifactFrame then
				_G.ArtifactFrame:RegisterEvent("ARTIFACT_UPDATE")
			end
			_G.UIParent:RegisterEvent("ARTIFACT_UPDATE")
		end
	end
end

lib.UpdateArtifactLevel=function()
	if not HeddDB.artifact then return end
	if _G.ArtifactFrame and _G.ArtifactFrame:IsShown() and Hedd.aui.GetNumObtainedArtifacts()>0 and HasArtifactEquipped() and not UnitHasVehicleUI("player") then
		Heddtalents:UnregisterEvent("ARTIFACT_UPDATE")
		_G.UIParent:UnregisterEvent("ARTIFACT_UPDATE")
		_G.ArtifactFrame:UnregisterEvent("ARTIFACT_UPDATE")
		cfg.Artifact.itemID, cfg.Artifact.altItemID, cfg.Artifact.name, cfg.Artifact.icon, cfg.Artifact.xp, cfg.Artifact.pointsSpent, cfg.Artifact.quality, cfg.Artifact.artifactAppearanceID, cfg.Artifact.appearanceModID, cfg.Artifact.itemAppearanceID, cfg.Artifact.altItemAppearanceID, cfg.Artifact.altOnTop = Hedd.aui.GetEquippedArtifactInfo()
		cfg.Artifact.currentArtifactPurchasableTraits = MainMenuBar_GetNumArtifactTraitsPurchasableFromXP(cfg.Artifact.pointsSpent, cfg.Artifact.xp)
		cfg.Artifact.powers=Hedd.aui.GetPowers()
		if cfg.Artifact.powers then
			for i = 1, #cfg.Artifact.powers do
				local spellID, cost, currentRank, maxRank, bonusRanks, x, y, prereqsMet, isStart, isGoldMedal, isFinal = Hedd.aui.GetPowerInfo(cfg.Artifact.powers[i])
				local name, _, texture = GetSpellInfo(spellID);
				cfg.Artifact.traits[spellID]={
					traitID=cfg.Artifact.powers[i],
					cost=cost,
					currentRank=currentRank,
					maxRank=maxRank,
					bonusRanks=bonusRanks,
					x=x,
					y=y,
					prereqsMet=prereqsMet,
					isGoldMedal=isGoldMedal,
					isFinal=isFinal,
					name=name,
					texture=texture,
					}
			end
		end
		cfg.Artifact.known=true
		Heddtalents:RegisterEvent("ARTIFACT_UPDATE")
		_G.ArtifactFrame:RegisterEvent("ARTIFACT_UPDATE")
		_G.UIParent:RegisterEvent("ARTIFACT_UPDATE")
	end
end


lib.IsPlayerTrait=function(ID)
	if cfg.Artifact.traits[ID] then
		return cfg.Artifact.traits[ID].currentRank or 0
	end
	return 0
end